/************************************************
 *  DSP Radio Control Program
 *   AKC6955  + PIC16F18326
 **********************************************/
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"
// ϐ`
uint8_t State, CHL, CHH, RSSI;
char Line1[17], Line2[17];
uint8_t temp, pga_rf, pga_lf, level, BAND, Flag;
uint16_t SetFreq;
double Freq;
// t\@RgXgp萔
//#define CONTRAST  0x18                      // for 5.0V
#define CONTRAST  0x30                      // for 3.3V
#define FM 1
#define AM 0
// ֐vg
void UpDown(void);
void Disp(void);
void BAND_SW(void);
void ContFreq(uint8_t band, uint16_t Freq);
void lcd_data(char data);
void lcd_cmd(char cmd);
void lcd_init(void);
void lcd_str(char* ptr);
/*******************************
 * ^C}O 荞ݏ
 ******************************/
void Timer0_ISR(void){
    Flag = 1;
}
/********* C֐ *************************/
void main(void)
{
    SYSTEM_Initialize();
    // t\평
    lcd_init();
    // 荞Callback֐`
    TMR0_SetInterruptHandler(Timer0_ISR);
    IOCCF0_SetInterruptHandler(BAND_SW);
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    // DSP6955 Initial Setting 
    BAND_SW();
    /**** C[v **************/
    while (1)
    {
        /***** gAbv_E@*****/
        UpDown();
        __delay_ms(50);                     // XVԊu        
        /**** gAMx\ *******/ 
        if(Flag == 1){                      // 0.5b
            Flag = 0;
            Disp();                         // \s
        }
    }
}
/************************************
 * ohؑ֊荞ݏTu
 *  XChXCb`ωŊ荞
 ***********************************/
void BAND_SW(void){
    __delay_ms(200);
    // AM FMohؑ
    if(Band_GetValue() == 0){   // FM̏ꍇ
        BAND = FM;
        I2C1_Write1ByteRegister(0x10, 0x00, 0xC0);      // FM Mode
        I2C1_Write1ByteRegister(0x10, 0x01, 0x11);      // MW2 FM2
        SetFreq = 2188;                                 // 84.7 FM Yokohama
        ContFreq(FM, SetFreq);
    }
    else{                       // AM̏ꍇ
        BAND = AM;
        I2C1_Write1ByteRegister(0x10, 0x00, 0x80);      // AM Mode
        I2C1_Write1ByteRegister(0x10, 0x01, 0x11);      // MW2 FM2
        SetFreq = 414;                                  // 1242kHz Nippon
        ContFreq(AM, SetFreq);     
    } 
    // AKC6955  
    I2C1_Write1ByteRegister(0x10, 0x06, 0xFC);          // Max Volume nonInverrt
    I2C1_Write1ByteRegister(0x10, 0x07, 0x11);          // bass boost auto stereo
    I2C1_Write1ByteRegister(0x10, 0x09, 0x0F);          // XTAL Volume I2C
    I2C1_Write1ByteRegister(0x10, 0x0B, 0xC0);          // 25kHz Step
    I2C1_Write1ByteRegister(0x10, 0x0D, 0x00);          // LED Tuned, vol=0dB    
}
/*********************************
 * gAbv_ETu
 *********************************/
void UpDown(void){
    if(BAND == FM){    // FMoh̏ꍇ
        // gAbv
        if(Up_GetValue() == 0){         // `FbN
            SetFreq++;
            if(SetFreq >= 2600)
                SetFreq = 1800;         // Min 75MHz
            ContFreq(FM, SetFreq);      // gݒ
            Disp();
        }
        // g_E
        if(Down_GetValue() == 0){       // `FbN
            SetFreq--;
            if(SetFreq <= 1800)         // Min 75MHz
                SetFreq = 2600;         // Max 95MHz
            ContFreq(FM, SetFreq);     // gݒ
            Disp();
        }
    }
    if(BAND == AM){    // AMoh̏ꍇ
        // gAbv
        if(Up_GetValue() == 0){         // `FbN
            SetFreq += 1;
            if(SetFreq >= 500)          // Max 1500kHz/3
                SetFreq = 170;          // Min 510kHz
            ContFreq(AM, SetFreq);     // gݒ
            Disp();
        }
        // g_E
        if(Down_GetValue() == 0){       // `FbN
            SetFreq -= 1;
            if(SetFreq <= 170)          // Min 510kHz/3
                SetFreq = 500;
            ContFreq(AM, SetFreq);      // gݒ
            Disp();           
        }            
    }
}
/*************************************
 *  gݒTu
 **************************************/
void ContFreq(uint8_t band, uint16_t Freq){
    // gݒ
    I2C1_Write1ByteRegister(0x10, 0x03, (uint8_t)(SetFreq & 0xFF));
    I2C1_Write1ByteRegister(0x10, 0x02,(uint8_t)((SetFreq >> 8) | 0x60));
    if(band == FM){
         // Tune Trigger
        I2C1_Write1ByteRegister(0x10, 0x00, 0xE0);
        I2C1_Write1ByteRegister(0x10, 0x00, 0xC0);       
    }
    else{
        // Tune Trigger 
        I2C1_Write1ByteRegister(0x10, 0x00, 0xA0);         // AM mode Trigger On
        I2C1_Write1ByteRegister(0x10, 0x00, 0x80);         // AM mode Trigger Off
    }   
}
/*************************************
 * gAMxt\Tu
 *************************************/
void Disp(void){
    if(BAND == FM){
        // `lg\
        CHL = I2C1_Read1ByteRegister(0x10, 0x03);               // gʎ擾
        CHH = I2C1_Read1ByteRegister(0x10, 0x02) & 0x1F;        // gʎ擾
        Freq = (CHH*256 + CHL)*0.025 + 30;                      // gɕϊ
        sprintf(Line1, "Freq= %3.1f MHz", Freq);                // ɕϊ
        lcd_cmd(0x80);                                          // 1sڂɕ\
        lcd_str(Line1);
    }
    if(BAND == AM){
        // `lg\
        CHL = I2C1_Read1ByteRegister(0x10, 0x03);               // gʎ擾
        CHH = I2C1_Read1ByteRegister(0x10, 0x02) & 0x1F;        // gʎ擾
        Freq = (double)(CHH*256 + CHL)*3;                       // gɕϊ
        sprintf(Line1, "Freq= %4.0f kHz   ", Freq);             // ɕϊ
        lcd_cmd(0x80);                                          // 1sڂɕ\
        lcd_str(Line1);        
    }
    // Mx\
    RSSI = I2C1_Read1ByteRegister(0x10, 0x1B) & 0x7F;           // RSSI擾
    temp = I2C1_Read1ByteRegister(0x10, 0x18);                  // x擾
    pga_rf = (temp >> 5) & 0x07;                                // R
    pga_lf = (temp >> 2) & 0x07;                                // L
    if(BAND == FM)
        level = 103-RSSI-6*pga_rf-6*pga_lf;                     // xɕϊ
    else
        level = 123-RSSI-6*pga_rf-6*pga_lf;                     // xɕϊ
    sprintf(Line2, "RSSI=%3d  S=%3d", RSSI, level);             // ɕϊ
    lcd_cmd(0xC0);                                              // Qsڂɕ\
    lcd_str(Line2);    
}
/*********************************
* t1\f[^o
*********************************/
void lcd_data(char data){
    I2C1_Write1ByteRegister(0x3E, 0x40, data); 
    __delay_us(30);                             // ҂x
}
/*******************************
* tւPR}ho
*******************************/
void lcd_cmd(char cmd){
    I2C1_Write1ByteRegister(0x3E, 0x00, cmd);
    /* ClearHomêƂx */
    if((cmd == 0x01)||(cmd == 0x02))
        __delay_ms(2);                      // 2msec҂
    else
        __delay_us(30);                     // 30sec҂
}
/*******************************
*  t\@֐
*******************************/
void lcd_init(void){
    __delay_ms(150);                // n[h҂
    lcd_cmd(0x38);                  // 8bit 2line Normal mode
    lcd_cmd(0x39);                  // 8bit 2line Extend mode
    lcd_cmd(0x14);                  // OSC 183Hz BIAS 1/5
    /* RgXgݒ */
    lcd_cmd(0x70 + (CONTRAST & 0x0F));
    lcd_cmd(0x5C + (CONTRAST >> 4));
//    lcd_cmd(0x6B);                // Follower for 5.0V
    lcd_cmd(0x6B);                  // Ffollwer for 3.3V
    __delay_ms(300);
    lcd_cmd(0x38);                  // Set Normal mode
    lcd_cmd(0x0C);                  // Display On
    lcd_cmd(0x01);                  // Clear Display
}
/*****************************
* t\@\֐
*****************************/
void lcd_str(char* ptr){
    while(*ptr != 0)                // Ō܂
        lcd_data(*ptr++);           // \s
}
